#ifndef _OFNFS_H_
#define _OFNFS_H_

#include <fsproto.h>
#include <dprintf.h>
#include <SupportDefs.h>
#include <lock.h>
#include <BeBuild.h>

#define DEBUG_BASE 0
#define debug(a,b) if ( (a == -1) || (a >= DEBUG_BASE)) dprintf b

static vnode_id the_one = 0xbeefe001;
static vnode_id root_vnid = 0xbeefe000;
static bool die_die_die = false;

typedef struct vnode {
	vnode_id		vnid;
	vnode_id		parent_vnid;
	lock 			lock;
	char			filename[B_FILE_NAME_LENGTH];
	uint32			last_rename_time;
} vnode;

typedef struct parms_t {
	int port;
} parms_t;

typedef struct nspace {
	nspace_id		nsid;
	int				sockid;
	uint32			connect_state;
	parms_t			params;
	//uchar			Flags;
	vnode			*root_vnode;
	vnode			*file_vnode;
	thread_id	listener_thread;
	sem_id		listener_sem;
} nspace;

typedef struct _filecookie {
	int			omode;
} filecookie;

typedef struct _dircookie {
	int				index;
} dircookie;

#endif // _OFNFS_H_